/****************************************************************************
 *	Copylight(C) 2011 Kanazawa-soft-design,LLC.All Rights Reserved.
 ****************************************************************************/
/*!
 *	@file	sample_0011.cpp
 *
 *	@brief	DirectSound𗘗pTEh̓vO.
 *
 *	@author	V 閾
 */
#include <windows.h>
#include <windowsX.h>
#include <stdio.h>
#include <commctrl.h>
#include <dsound.h>
#include <tchar.h>
#include <math.h>
#include "resource.h"
#include "WaveFile.h"

// V{`.
#define	SMPFRQ			48000				//!< TvOg.
#define	BUFSIZE			((SMPFRQ * 4) / 10)	//!< f[^obt@TCY (100ms).

// ֐vg^Cv.
static LRESULT CALLBACK	SoundOutProc( HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam );
static void				OnInitDialog( HWND hDlg );
static BOOL CALLBACK	DSEnumCallback( LPGUID guid, LPCTSTR desc, LPCTSTR module, LPVOID user );
static BOOL				OnSelectFile( HWND hDlg );
static BOOL				RecSound( HWND hDlg );
static void				PauseSound( HWND hDlg );
static void				StopSound( HWND hDlg );
static BOOL				OpenSoundCapDevice( HWND hDlg, UINT num, WAVEFORMATEX* wf );
static void				CloseSoundCapDevice( void );
static DWORD WINAPI		CaptureEventTask( void* user );
static BOOL				OpenSoundOutDevice( HWND hDlg, UINT num, WAVEFORMATEX* wf );
static void				CloseSoundOutDevice( void );
static DWORD WINAPI		OutputEventTask( void* user );
static DWORD			PutCaptureData( BYTE* buf, DWORD len, DWORD pos );
static DWORD			GetCaptureData( BYTE* buf, DWORD size, DWORD pos );
static long				VolumeControl( HWND hVolume );
static long				BalanceControl( HWND hVolume );

// [Jϐ.
static BOOL							RecFlag;				//!< TRUE = ^.
static DWORD						DevCnt[2];				//!< o̓foCX̌.
static GUID							DevGuid[2][10];			//!< o̓foCXGUIDe[u.
static TCHAR						DevName[2][10][64];		//!< o̓foCX̖Oe[u.
static TCHAR						FileName[MAX_PATH+1];	//!< ĐWAVt@C̃t@C.

static BOOL							OutState;				//!< TRUE = TEho͏.
static HANDLE						OutEvent[2];			//!< o̓CxgEIuWFNg.
static DWORD						OutBufSize;				//!< Xg[obt@ETCY.
static DWORD						OutPos;					//!< Xg[obt@̏݊Jnʒu.
static BOOL							CapState;				//!< TRUE = TEh͏.
static LPDIRECTSOUND8				OutDev;					//!< IDirectSound8C^[tFCX |C^.
static LPDIRECTSOUNDBUFFER			OutBuf;					//!< IDirectSoundBufferC^[tFCX |C^.

static HANDLE						CapEvent[2];			//!< ̓CxgEIuWFNg.
static DWORD						CapBufSize;				//!< Lv`obt@ETCY.
static DWORD						GetPos;					//!< Lv`obt@̓ǂݍ݊Jnʒu.
static DWORD						PutPos;					//!< Lv`obt@̏݊Jnʒu.
static BYTE*						DataBuff;				//!< f[^obt@.
static LPDIRECTSOUNDCAPTURE8		CapDev;					//!< IDirectSoundCapture8C^[tFCX |C^.
static LPDIRECTSOUNDCAPTUREBUFFER	CapBuf;					//!< IDirectSoundBufferC^[tFCX |C^.



/****************************************************************************/
/*!
 *	@brief	AvP[VEC.
 *
 *	@param	[in]	hInst		݂̃CX^X̃nh.
 *	@param	[in]	hPreInst	ȑÕCX^X̃nh.
 *	@param	[in]	CmdLine		R}hC.
 *	@param	[in]	show		\.
 *
 *	@retval	0Ԃ.
 */
int WINAPI	WinMain( HINSTANCE hInst, HINSTANCE hPreInst, LPSTR CmdLine, int show )
{
	//! [Jϐ.
	RecFlag     = FALSE;
	DataBuff    = NULL;
	OutState    = FALSE;
	OutBufSize  = 0;
	CapBufSize  = 0;
	OutPos      = 0;
	GetPos      = 0;
	PutPos      = 0;
	OutDev      = NULL;
	OutBuf      = NULL;
	CapDev      = NULL;
	CapBuf      = NULL;
	memset( DevCnt  , 0, sizeof(DevCnt)   );
	memset( DevGuid , 0, sizeof(DevGuid)  );
	memset( DevName , 0, sizeof(DevName)  );
	memset( OutEvent, 0, sizeof(OutEvent) );
	memset( CapEvent, 0, sizeof(CapEvent) );
	memset( FileName, 0, sizeof(FileName) );

	//! RRg[.
    INITCOMMONCONTROLSEX ic;
	ic.dwSize = sizeof(INITCOMMONCONTROLSEX);
	ic.dwICC  = ICC_COOL_CLASSES;
	InitCommonControlsEx( &ic );

	//! _CAOI[v.
	DialogBox( hInst, MAKEINTRESOURCE(IDD_DIALOG_MAIN), NULL, (DLGPROC)SoundOutProc );

	return 0;
}

/****************************************************************************/
/*!
 *	@brief	_CAÕbZ[WEnh.
 *
 *	@param	[in]	hDlg	_CAO{bNX̃nh.
 *	@param	[in]	msg		bZ[W.
 *	@param	[in]	wParam	ŏ̃bZ[Wp[^.
 *	@param	[in]	lParam	2Ԗڂ̃bZ[Wp[^.
 *
 *	@retval	TRUE  = bZ[W.
 *	@retval	FALSE = bZ[WȂ.
 */
static LRESULT CALLBACK		SoundOutProc( HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam )
{
	switch( msg ){
	case WM_INITDIALOG:
		OnInitDialog( hDlg );
		break;

	case WM_COMMAND:
		switch( LOWORD(wParam) ){
		case IDC_FILE_SELECT:
			OnSelectFile( hDlg );
			break;

		case IDC_REC:
			if( !RecSound( hDlg ) ){
				StopSound( hDlg );
			}
			break;

		case IDC_PAUSE:
			PauseSound( hDlg );
			break;

		case IDC_STOP:
			StopSound( hDlg );
			break;

		case IDCANCEL:
			StopSound( hDlg );
			EndDialog( hDlg, 0 );
			break;

		default:
			return FALSE;
		}
		break;

	case WM_VSCROLL:
		if( GetDlgItem( hDlg, IDC_VOLUME ) == (HWND)lParam ){
			VolumeControl( (HWND)lParam );
		}
		break;

	case WM_HSCROLL:
		if( GetDlgItem( hDlg, IDC_BALANCE ) == (HWND)lParam ){
			BalanceControl( (HWND)lParam );
		}
		break;

	default:
		break;
	}
	return FALSE;
}

/****************************************************************************/
/*!
 *	@brief	_CAȌ.
 *
 *	@param	[in]	hDlg	_CAÕEChEEnh.
 *
 *	@retval	Ȃ.
 */
static void		OnInitDialog( HWND hDlg )
{
	//! DirectSound̏o̓foCXXgAbv.
	DevCnt[0] = 0;
	DirectSoundEnumerate( DSEnumCallback, (void*)0 );

	//! o̓foCXXg쐬.
	if( DevCnt[0] != 0 ){
		HWND hlist = GetDlgItem( hDlg, IDC_OUTPUT_DEVICE );
		ComboBox_ResetContent( hlist );
		for( DWORD i = 0; i < DevCnt[0]; i++ ){
			ComboBox_AddString( hlist, DevName[0][i] );
		}
		ComboBox_SetCurSel( hlist, 0 );
	}
	// DirectSound̓̓foCXXgAbv.
	DevCnt[1] = 0;
	DirectSoundCaptureEnumerate( DSEnumCallback, (void*)1 );

	// ̓foCXXg쐬.
	if( DevCnt[1] != 0 ){
		HWND hlist = GetDlgItem( hDlg, IDC_INPUT_DEVICE );
		ComboBox_ResetContent( hlist );
		for( DWORD i = 0; i < DevCnt[1]; i++ ){
			ComboBox_AddString( hlist, DevName[1][i] );
		}
		ComboBox_SetCurSel( hlist, 0 );
	}
	//! ʃ{[̃gbNo[ݒ肷.
	HWND hbar = GetDlgItem( hDlg, IDC_VOLUME );
	SendMessage( hbar, TBM_SETRANGE, TRUE, MAKELONG( 0, 100 ) );
	SendMessage( hbar, TBM_SETPOS  , TRUE, 50 );

	//! ʃoX̃gbNo[ݒ肷.
	hbar = GetDlgItem( hDlg, IDC_BALANCE );
	SendMessage( hbar, TBM_SETRANGE, TRUE, MAKELONG( 0, 100 ) );
	SendMessage( hbar, TBM_SETPOS  , TRUE, 50 );
}

/****************************************************************************/
/*!
 *	@brief	o̓foCX񋓎̃R[obN֐.
 *
 *	@param	[in]	guid	foCXʂGIUD.
 *	@param	[in]	desc	DirectSoundfoCX̐.
 *	@param	[in]	module	DirectSoundhCõW[.
 *	@param	[in]	user	[U[`ϐ.
 *
 *	@retval	TRUE = ̃foCX擾 / FALSE = foCX̗񋓂I.
 */
static BOOL CALLBACK	DSEnumCallback( LPGUID guid, LPCTSTR desc, LPCTSTR module, LPVOID user )
{
	DWORD idx = (DWORD)user;
	DWORD num = DevCnt[idx];

	//! mۂĂ郊XgTCY𒴂Ă܂ꍇAfoCX̗񋓂I.
	if( num >= 10 ){
		return FALSE;
	}
	//! "vC} foCX"̓XgɓȂ.
	if( !guid || !desc ){
		return TRUE;
	}
	//! o̓foCXGUIDۑ.
	DevGuid[idx][num] = *guid;

	//! o̓foCXۑ.
	_tcsncpy_s( DevName[idx][num], desc, 63 );

	//! o̓foCX̌+1.
	DevCnt[idx]++;
	return TRUE;
}

/****************************************************************************/
/*!
 *	@brief	^WAVt@CI.
 *
 *	@param	[in]	hDlg	_CAÕEChEEnh.
 *
 *	@retval	Ȃ.
 */
static BOOL		OnSelectFile( HWND hDlg )
{
	//! ^WAVt@Ct@CI_CAOI.
	OPENFILENAME ofn;
	memset( &ofn     , 0, sizeof(ofn)      );
	memset( &FileName, 0, sizeof(FileName) );
	ofn.lStructSize    = sizeof(ofn);
	ofn.hwndOwner      = hDlg;
	ofn.lpstrFilter    = _T("WAVEt@C(*.wav)\0*.wav\0SẴt@C(*.*)\0*.*\0\0");
	ofn.lpstrFile      = FileName;
	ofn.nMaxFile       = MAX_PATH;
	ofn.Flags          = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
	ofn.lpstrDefExt    = NULL;
	ofn.lpstrTitle     = _T("^t@C");
	if( GetSaveFileName( &ofn ) ){
		SetWindowText( GetDlgItem( hDlg, IDC_FILENAME ), FileName );
		return TRUE;
	}
	return FALSE;
}

/****************************************************************************/
/*!
 *	@brief	O̘^Jn.
 *
 *	@param	[in]	hDlg	_CAÕEChEEnh.
 *
 *	@retval	TRUE = OK. / FALSE = NG.
 */
static BOOL		RecSound( HWND hDlg )
{
	if( !CapDev ){
		//! I[fBIEf[^EtH[}bgݒ肷.
		WAVEFORMATEX wf;
		wf.wFormatTag      = WAVE_FORMAT_PCM;
		wf.nChannels       = 2;
		wf.wBitsPerSample  = 16;
		wf.nBlockAlign     = 4;
		wf.nSamplesPerSec  = SMPFRQ;
		wf.nAvgBytesPerSec = SMPFRQ * wf.nBlockAlign;
		wf.cbSize          = 0;

		//! _CAOĐWAVt@C擾.
		GetWindowText( GetDlgItem( hDlg, IDC_FILENAME ), FileName, sizeof(FileName) - 1 );

		//! ۑWAVt@CVK쐬ŃI[v.
		int result = SaveOpenWaveFile( FileName, &wf, FALSE );
		if( result == -2 ){
			//! ̃t@CꍇA㏑邩ǂ₢킹.
			if( MessageBox( hDlg, _T("Ƀt@C݂Ă܂B㏑܂H"), _T("WAVt@C̕ۑ"), MB_YESNO ) == IDYES ){

				//! ㏑[hŃt@CI[v.
				result = SaveOpenWaveFile( FileName, &wf, TRUE );
			}else{
				return FALSE;
			}
		}
		if( result != 0 ){
			MessageBox( hDlg, _T("t@CI[vł܂"), _T("WAVt@C̕ۑ"), MB_OK );
			return FALSE;
		}

		//! TEh̓foCXI[v.
		UINT num = ComboBox_GetCurSel( GetDlgItem( hDlg, IDC_INPUT_DEVICE ) );
		if( !OpenSoundCapDevice( hDlg, num, &wf ) ){
			return FALSE;
		}
		//! TEho̓foCXI[v.
		num = ComboBox_GetCurSel( GetDlgItem( hDlg, IDC_OUTPUT_DEVICE ) );
		if( !OpenSoundOutDevice( hDlg, num, &wf ) ){
			return FALSE;
		}

		//! ǂݍ݃obt@mۂ.
		if( !DataBuff ){
			DataBuff = new BYTE[CapBufSize];
			memset( DataBuff, 0, CapBufSize );
		}
		//! {[ݒ_CAO̐ݒɂ킹.
		VolumeControl( GetDlgItem( hDlg, IDC_VOLUME ) );

		//! oXݒ_CAO̐ݒɂ킹.
		VolumeControl( GetDlgItem( hDlg, IDC_BALANCE ) );

		//! ĐJ[\̈ʒu.
		OutPos = 0;
		OutBuf->SetCurrentPosition( 0 );

		//! TEho͂Jn.
		OutBuf->Play( 0, 0, DSBPLAY_LOOPING );

		//! Lv`Jn.
		GetPos = (CapBufSize >> 1);
		PutPos = 0;
		CapBuf->Start( DSCBSTART_LOOPING );
	}
	//! ^撆tOZbg.
	RecFlag = TRUE;

	EnableWindow( GetDlgItem( hDlg, IDC_REC           ), FALSE );
	EnableWindow( GetDlgItem( hDlg, IDC_PAUSE         ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_STOP          ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_FILENAME      ), FALSE );
	EnableWindow( GetDlgItem( hDlg, IDC_FILE_SELECT   ), FALSE );
	EnableWindow( GetDlgItem( hDlg, IDC_OUTPUT_DEVICE ), FALSE );
	EnableWindow( GetDlgItem( hDlg, IDC_INPUT_DEVICE  ), FALSE );
	return TRUE;
}

/****************************************************************************/
/*!
 *	@brief	O̘^ꎞ~.
 *
 *	@param	[in]	hDlg	_CAÕEChEEnh.
 *
 *	@retval	Ȃ.
 */
static void		PauseSound( HWND hDlg )
{
	//! ^撆tONA.
	RecFlag = FALSE;

	EnableWindow( GetDlgItem( hDlg, IDC_REC           ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_PAUSE         ), FALSE );
	EnableWindow( GetDlgItem( hDlg, IDC_STOP          ), FALSE );
	EnableWindow( GetDlgItem( hDlg, IDC_FILENAME      ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_FILE_SELECT   ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_OUTPUT_DEVICE ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_INPUT_DEVICE  ), TRUE  );
}

/****************************************************************************/
/*!
 *	@brief	O̘^~.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
static void		StopSound( HWND hDlg )
{
	//! TEho̓foCXN[Y.
	CloseSoundCapDevice();

	//! TEho̓foCXN[Y.
	CloseSoundOutDevice();

	//! ĐWAVt@CN[Y.
	CloseWaveFile();

	//! ǂݍ݃obt@.
	if( DataBuff ){
		delete [] DataBuff;
		DataBuff = NULL;
	}
	//! ^撆tONA.
	RecFlag = FALSE;

	EnableWindow( GetDlgItem( hDlg, IDC_REC           ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_PAUSE         ), FALSE );
	EnableWindow( GetDlgItem( hDlg, IDC_STOP          ), FALSE );
	EnableWindow( GetDlgItem( hDlg, IDC_FILENAME      ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_FILE_SELECT   ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_OUTPUT_DEVICE ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_INPUT_DEVICE  ), TRUE  );
}

/****************************************************************************/
/*!
 *	@brief	TEh̓foCXI[v.
 *
 *	@param	[in]	hDlg	_CAÕEChEEnh.
 *	@param	[in]	num		I[vfoCXԍ.
 *	@param	[in]	wf		ĐWAVt@C̃I[fBI\̂̃|C^.
 *
 *	@retval	TRUE = OK. / FALSE = NG.
 */
static BOOL		OpenSoundCapDevice( HWND hDlg, UINT num, WAVEFORMATEX* wf )
{
	//! DirectSound̃Lv`EIuWFNg쐬.
	if( DirectSoundCaptureCreate8( &DevGuid[1][num], &CapDev, NULL ) != S_OK ){
		return FALSE;
	}
	//! Lv`obt@EIuWFNg쐬.
	DSCBUFFERDESC desc;
	memset( &desc, 0, sizeof(desc) );
	desc.dwSize        = sizeof(desc);
	desc.dwFlags       = 0;
	desc.dwBufferBytes = BUFSIZE;
	desc.lpwfxFormat   = wf;
	if( CapDev->CreateCaptureBuffer( &desc, &CapBuf, NULL ) != DS_OK ){
		return FALSE;
	}
	// mۂꂽLv`Eobt@̃TCY擾.
	DSCBCAPS caps;
	memset( &caps, 0, sizeof(caps) );
	caps.dwSize = sizeof(caps);
	if( CapBuf->GetCaps( &caps ) == DS_OK ){
		CapBufSize = caps.dwBufferBytes;
	}
	// Lv`ECxg̃IuWFNg쐬.
	for( int i = 0; i < 2; i++ ){
		CapEvent[i] = CreateEvent( NULL, FALSE, FALSE, NULL );
	}
	LPDIRECTSOUNDNOTIFY8 Notify;
	if( CapBuf->QueryInterface( IID_IDirectSoundNotify, (LPVOID*)&Notify ) != DS_OK ){
		return FALSE;
	}
	//! Lv`ECxgݒ肷.
	DSBPOSITIONNOTIFY pos[2];
	pos[0].dwOffset     = (CapBufSize / 2) - 1;
	pos[0].hEventNotify = CapEvent[0];
	pos[1].dwOffset     = CapBufSize - 1;
	pos[1].hEventNotify = CapEvent[1];
	Notify->SetNotificationPositions( 2, pos );
	Notify->Release();

	CapState = TRUE;

	//! Cxg^XNN.
	DWORD tid;
	CreateThread( NULL, 0, CaptureEventTask, NULL, 0, &tid );
	return TRUE;
}

/****************************************************************************/
/*!
 *	@brief	TEh̓foCXN[Y.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
static void		CloseSoundCapDevice( void )
{
	if( CapDev || CapBuf ){
		// Lv`~.
		if( CapBuf ){
			CapBuf->Stop();
		}
		// CxgĎ^XN~.
		CapState = FALSE;
		if( CapEvent[0] ){
			SetEvent( CapEvent[0] );
			Sleep( 500 );
		}
		// DirectSound̃Lv`pIuWFNg.
		if( CapBuf ){
			CapBuf->Release();
			CapBuf = NULL;
		}
		if( CapDev ){
			CapDev->Release();
			CapDev = NULL;
		}
		// Lv`ECxg̃IuWFNg.
		for( int i = 0; i < 2; i++ ){
			if( CapEvent[i] ){
				CloseHandle( CapEvent[i] );
				CapEvent[i] = NULL;
			}
		}
	}
}

/****************************************************************************/
/*!
 *	@brief	f[^̓CxgĎ^XN.
 *
 *	@param	[in]	user	gpȂ.
 *
 *	@retval	TRUE = OK. / FALSE = NG.
 */
static DWORD WINAPI		CaptureEventTask( void* user )
{
	while( CapState ){
		switch( WaitForMultipleObjects( 2, CapEvent, 0, INFINITE ) ){
		case WAIT_OBJECT_0 + 0:
		case WAIT_OBJECT_0 + 1:
			if( CapState ){
				//! ǂݍ݉\ȃobt@ʒu擾.
				DWORD n        = 0;
				DWORD read_pos = 0;
				DWORD dummy    = 0;
				CapBuf->GetCurrentPosition( &dummy, &read_pos );

				//! WAVt@Cɏo擪̃f[^ʒuۑĂ.
				DWORD wav_pos = PutPos;

				/*!
				 * ǂݍ݃J[\ƃobt@̎̃f[^̓ǂݍ݊Jnʒu
				 * ǂݍ݉\ȗ̈̃oCgvZ.
				 * (obt@̊֌WAǂݍރTCY͍őŃobt@1/2𒴂Ȃ悤ɂ.)
				 */
				if( PutPos > read_pos ){
					n = (CapBufSize + read_pos) - PutPos;
				}else
				if( PutPos < read_pos ){
					n = read_pos - PutPos;
				}
				DWORD len = (n >= (CapBufSize >> 1)) ? (CapBufSize >> 1) : n;

				//! f[^ǂݍޗ̈bN.
				void*	buf1 = NULL;
				void*	buf2 = NULL;
				DWORD	len1 = 0;
				DWORD	len2 = 0;
				CapBuf->Lock( PutPos, len, &buf1, &len1, &buf2, &len2, 0 );

				//! ǂݍ݃obt@ɃLv`f[^Rs[.
				if( buf1 && len1 ){
					PutPos = PutCaptureData( (BYTE*)buf1, len1, PutPos );
				}
				//! Lv`Eobt@̐擪ɖ߂ꍇAc̃f[^Rs[.
				if( buf2 && len2 ){
					PutPos = PutCaptureData( (BYTE*)buf2, len2, PutPos );
				}
				//! ǂݏo̊obt@AbN.
				CapBuf->Unlock( buf1, len1, buf2, len2 ); 

				if( wav_pos > PutPos ){

					//! obt@̍Ōɂf[^WAVt@Cɏ.
					WritedWaveFile( &DataBuff[wav_pos], CapBufSize - wav_pos );

					//! obt@̐擪ɂc̃f[^WAVt@Cɏ.
					if( PutPos > 0 ){
						WritedWaveFile( DataBuff, PutPos );
					}
				}else{
					//! Lv`f[^WAVt@Cɏ.
					WritedWaveFile( &DataBuff[wav_pos], PutPos - wav_pos );
				}
			}
			break;
		}
	}
	return 0;
}

/****************************************************************************/
/*!
 *	@brief	TEho̓foCXI[v.
 *
 *	@param	[in]	hDlg	_CAÕEChEEnh.
 *	@param	[in]	num		I[vfoCXԍ.
 *	@param	[in]	wf		ĐWAVt@C̃I[fBI\̂̃|C^.
 *
 *	@retval	TRUE = OK. / FALSE = NG.
 */
static BOOL		OpenSoundOutDevice( HWND hDlg, UINT num, WAVEFORMATEX* wf )
{
	//! DirectSound̍ĐIuWFNg쐬.
    if( DirectSoundCreate8( &DevGuid[0][num], &OutDev, NULL ) != S_OK ){
		return FALSE;
	}
	//! ĐIuWFNgɑ΂AvP[V̋xݒ肷.
	if( OutDev->SetCooperativeLevel( hDlg, DSSCL_PRIORITY ) != DS_OK ){
		return FALSE;
	}
	//! Xg[obt@EIuWFNg쐬.
	DSBUFFERDESC desc;
	memset( &desc, 0, sizeof(desc) );
    desc.dwSize  = sizeof(desc);
	desc.dwFlags = DSBCAPS_GLOBALFOCUS
				 | DSBCAPS_CTRLPOSITIONNOTIFY
				 | DSBCAPS_CTRLVOLUME
				 | DSBCAPS_CTRLPAN;
	desc.dwBufferBytes = CapBufSize;
    desc.lpwfxFormat   = wf;
	if( OutDev->CreateSoundBuffer( &desc, &OutBuf, NULL ) != DS_OK ){
		return FALSE;
	}
	//! mۂꂽXg[obt@̃TCY擾.
	DSBCAPS caps;
	memset( &caps, 0, sizeof(caps) );
	caps.dwSize = sizeof(caps);
	if( OutBuf->GetCaps( &caps ) == DS_OK ){
		OutBufSize = caps.dwBufferBytes;
	}
	//! ĐCxg̃IuWFNg쐬.
	for( int i = 0; i < 2; i++ ){
		OutEvent[i] = CreateEvent( NULL, FALSE, FALSE, NULL );
	}
	LPDIRECTSOUNDNOTIFY8 Notify;
	if( OutBuf->QueryInterface( IID_IDirectSoundNotify, (LPVOID*)&Notify ) != DS_OK ){
		return FALSE;
	}
	//! ĐCxgݒ肷.
	DSBPOSITIONNOTIFY pos[2];
	pos[0].dwOffset     = (OutBufSize / 2) - 1;
	pos[0].hEventNotify = OutEvent[0];
	pos[1].dwOffset     = OutBufSize - 1;
	pos[1].hEventNotify = OutEvent[1];
	Notify->SetNotificationPositions( 2, pos );
	Notify->Release();

	OutState = TRUE;

	//! Cxg^XNN.
	DWORD tid;
	CreateThread( NULL, 0, OutputEventTask, NULL, 0, &tid );
	return TRUE;
}

/****************************************************************************/
/*!
 *	@brief	TEho̓foCXN[Y.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
static void		CloseSoundOutDevice( void )
{
	if( OutDev || OutBuf ){
		//! TEho͂~.
		if( OutBuf ){
			OutBuf->Stop();
		}
		//! CxgĎ^XN~.
		OutState = FALSE;
		if( OutEvent[0] ){
			SetEvent( OutEvent[0] );
			Sleep( 500 );
		}
		//! DirectSound̃Xg[obt@.
		if( OutBuf ){
			OutBuf->Release();
			OutBuf = NULL;
		}
		//! DirectSound̍ĐIuWFNg.
		if( OutDev ){
			OutDev->Release();
			OutDev = NULL;
		}
		//! ĐCxg̃IuWFNg.
		for( int i = 0; i < 2; i++ ){
			if( OutEvent[i] ){
				CloseHandle( OutEvent[i] );
				OutEvent[i] = NULL;
			}
		}
	}
}

/****************************************************************************/
/*!
 *	@brief	f[^o̓CxgĎ^XN.
 *
 *	@param	[in]	user	gpȂ.
 *
 *	@retval	TRUE = OK. / FALSE = NG.
 */
static DWORD WINAPI		OutputEventTask( void* user )
{
	while( OutState ){
		switch( WaitForMultipleObjects( 2, OutEvent, 0, INFINITE ) ){
		case WAIT_OBJECT_0 + 0:
		case WAIT_OBJECT_0 + 1:

			if( OutState ){
				//! ݂̍ĐJ[\̈ʒu擾.
				DWORD n        = OutBufSize - OutPos;
				DWORD play_pos = 0;
				DWORD dummy    = 0;
				OutBuf->GetCurrentPosition( &play_pos, &dummy );

				//! Lv`obt@ɂoCgvZ.
				DWORD cap_len;
				if( GetPos < PutPos ){
					cap_len = PutPos - GetPos;
				}else
				if( GetPos > PutPos ){
					cap_len = (CapBufSize - GetPos) + PutPos;
				}else{
					cap_len = CapBufSize;
				}
				if( cap_len > (CapBufSize >> 1) ){
					cap_len = (CapBufSize >> 1);
				}
				/*
				 * ĐJ[\ƃobt@̎̃f[^̏݊Jnʒu
	 			 * ݉\ȗ̈̃oCgvZ.
				 */
				if( play_pos > OutPos ){
					n = play_pos - OutPos;
				}else
				if( play_pos < OutPos ){
					n = (OutBufSize - OutPos) + play_pos;
				}
				//! j^o͂f[^̓Lv`f[^zȂ悤ɂ.
				if( n > cap_len ){
					n = cap_len;
				}
				//! f[^ޗ̈bN.
				void*	buf1 = NULL;
				void*	buf2 = NULL;
				DWORD	len1 = 0;
				DWORD	len2 = 0;
				OutBuf->Lock( OutPos, n, &buf1, &len1, &buf2, &len2, 0 );

				//! ݃obt@Ƀj^f[^Rs[.
				if( buf1 && len1 ){
					GetPos  = GetCaptureData( (BYTE*)buf1, len1, GetPos );
					OutPos += len1;
				}
				//! ݗ̈悪obt@̐擪ɖ߂ꍇAc̃f[^Rs[.
				if( buf2 && len2 ){
					GetPos  = GetCaptureData( (BYTE*)buf2, len2, GetPos );
					OutPos += len2;
				}
				//! ̃f[^̏݊JnʒuXV.
				if( OutPos >= OutBufSize ){
					OutPos -= OutBufSize;
				}
				//! obt@̃bN.
				OutBuf->Unlock( buf1, len1, buf2, len2 ); 
			}
			break;
		}
	}
	return 0;
}

/****************************************************************************/
/*!
 *	@brief	Lv`Ef[^ǂݍ݃obt@Ɋi[.
 *
 *	@param	[in]	buf		Lv`Ef[^i[ꂽ̈̃|C^.
 *	@param	[in]	len		Lv`Ef[^̃oCg.
 *	@param	[in]	pos		ǂݍ݃obt@̃f[^݊Jnʒu.
 *
 *	@retval	ǂݍ݃obt@̎̃f[^݊Jnʒu.
 */
static DWORD	PutCaptureData( BYTE* buf, DWORD len, DWORD pos )
{
	if( (pos + len) > CapBufSize ){
		/*!
		 * i[f[^obt@ɓ肫ȂꍇAǂݍ݃obt@̍Ō
		 * i[ł邾Lv`f[^Rs[.
		 */
		DWORD wk_len = (CapBufSize - pos);
		memcpy( &DataBuff[pos], buf, wk_len );

		//! ǂݍ݃obt@̐擪Ɏc̃Lv`f[^Rs[.
		memcpy( DataBuff, &buf[wk_len], len - wk_len );

		//! ̃f[^̏݊JnʒuXV.
		pos = len - wk_len;
	}else{
		/*!
		 * i[f[^obt@ɓ肫ꍇÂ܂ܓǂݍ݃obt@
		 * Lv`f[^Rs[.
		 */
		memcpy( &DataBuff[pos], buf, len );

		//! ̃f[^̏݊JnʒuXV.
		pos += len;
		if( pos >= CapBufSize ){
			pos  = 0;
		}
	}
	return pos;
}

/****************************************************************************/
/*!
 *	@brief	Lv`Ef[^ǂݍ݃obt@ǂݏo.
 *
 *	@param	[in]	buf		Lv`Ef[^i[̈̃|C^.
 *	@param	[in]	size	Lv`Ef[^i[̈̃oCg.
 *	@param	[in]	pos		ǂݍ݃obt@̃f[^ǂݍ݊Jnʒu.
 *
 *	@retval	ǂݍ݃obt@̎̃f[^ǂݍ݊Jnʒu.
 */
static DWORD	GetCaptureData( BYTE* buf, DWORD size, DWORD pos )
{
	DWORD len = 0;

	//! obt@̓ǂݏoʒuɑSăf[^݂Ăꍇ.
	if( size > 0 && PutPos <= pos ){
		if( (pos + size) > CapBufSize ){
			/*!
			 * Rs[̃obt@̕傫ꍇARs[̃obt@̍Ō܂ł̃f[^
			 * Rs[Af[^̓ǂݍ݈ʒuRs[̃obt@̐擪ɂ.
			 */
			len = (CapBufSize - pos);
			memcpy( buf, &DataBuff[pos], len );

			pos = 0;
		}else{
			/*!
			 * Rs[̃obt@̕ꍇARs[̃obt@Rs[̃obt@
			 * TCYRs[Af[^̓ǂݍ݈ʒuXV.
			 */
			memcpy( buf, &DataBuff[pos], size );
			len  = size;
			pos += size;
		}
	}
	if( len < size ){
		DWORD remain = size - len;
		if( (pos + remain) > PutPos ){
			/*!
			 * Rs[̃obt@̕傫ꍇARs[̃obt@̃Lv`f[^݈ʒu܂ł
			 * f[^Rs[AȂf[^ 0 Ŗ߂.
			 * (ꉞsƂ́Aobt@䂪j]Ă.)
			 */
			DWORD wk_len = PutPos - pos;
			if( wk_len > 0 ){
				memcpy( &buf[len], &DataBuff[pos], wk_len );
				pos  = PutPos;
				len += wk_len;
			}
			memset( &buf[len], 0, size - len );
		}else{
			/*!
			 * Rs[̃obt@̕ꍇARs[̃obt@Rs[̃obt@
			 * TCYRs[Af[^̓ǂݍ݈ʒuXV.
			 */
			memcpy( &buf[len], &DataBuff[pos], remain );
			pos += remain;
		}
	}
	//! ̓ǂݏoʒuobt@TCY𒴂Ă܂Aǂݏoʒuobt@̐擪ɂ.
	if( pos >= CapBufSize ){
		pos  = 0;
	}
	return pos;
}

/****************************************************************************/
/*!
 *	@brief	ʃ{[ݒύX.
 *
 *	@param	[in]	hVolume	{[Rg[o[̃nh.
 *
 *	@retval	V{[ݒl.
 */
static long		VolumeControl( HWND hVolume )
{
	//! foCXI[vĂȂꍇA{[ݒsȂ.
	if( !OutBuf ){
		return 0;
	}
	//! _CAO{[Rg[̈ʒu擾.
	long range  = SendMessage( hVolume, TBM_GETPOS, 0, 0 );
	long volume = DSBVOLUME_MIN;
	if( range < 100 ){
		volume = (long)(1000.0 * log10( (100.0 - range) / 100.0 ));
	}
	if( volume < DSBVOLUME_MIN ){
		volume = DSBVOLUME_MIN;
	}else
	if( volume > DSBVOLUME_MAX ){
		volume = DSBVOLUME_MAX;
	}
	//! {[ݒύX.
	OutBuf->SetVolume( volume );

	return volume;
}

/****************************************************************************/
/*!
 *	@brief	ʃoXݒύX.
 *
 *	@param	[in]	hVolume	oXRg[o[̃nh.
 *
 *	@retval	VoXݒl.
 */
static long		BalanceControl( HWND hVolume )
{
	//! foCXI[vĂȂꍇAoXݒsȂ.
	if( !OutBuf ){
		return 0;
	}
	//! _CAOoXRg[̈ʒu擾.
	long range   = SendMessage( hVolume, TBM_GETPOS, 0, 0 );
	long balance = ((50 - range) * ((DSBPAN_RIGHT - DSBPAN_LEFT) / 2)) / 100;

	//! oXݒύX.
	OutBuf->SetPan( balance );

	return balance;
}

/* End of file */
